(function() {
  var ApiMapper, UrlGenerator, qreq, routes;

  routes = require("../src/routes");

  UrlGenerator = require("./url-generator");

  qreq = require("qreq");

  ApiMapper = (function() {
    function ApiMapper(config) {
      this.ug = new UrlGenerator(config);
    }

    ApiMapper.prototype.getUrl = function(fn, opts) {
      var config, option, route, _i, _len, _ref;
      if (opts == null) {
        opts = {};
      }
      config = {
        query: {},
        params: opts
      };
      route = routes[fn];
      if (route.options) {
        _ref = route.options;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          option = _ref[_i];
          if (opts[option]) {
            config.query[option] = opts[option];
          }
          delete opts[option];
        }
      }
      return this.ug.getUrl(route.endpoint, config);
    };

    ApiMapper.prototype.getMethod = function(fn) {
      return routes[fn].method;
    };

    ApiMapper.prototype.getRequestObject = function(fn, opts) {
      var method, url;
      if (opts == null) {
        opts = {};
      }
      method = this.getMethod(fn);
      url = this.getUrl(fn, opts);
      return qreq[method.toLowerCase()](url);
    };

    return ApiMapper;

  })();

  module.exports = ApiMapper;

}).call(this);
